<?php
if($_SERVER[PHP_SELF]=="/include/execute_db_backup.php")
{
   header("Location: /index.php");
   exit;
}
include("../require/config.php");
	/*
		|-----------------------------------------------------------------------|
		|   Example MySQL DB Backup 1.0.1 File                                  |
		|                     	                                                |
		|   Written by: Luis Arturo Aguilar Mendoza <minibikec@prodigy.net.mx>  |
		|   Released under GNU Public license.                                  |
		|                                                                       |
		|   Only use with MySQL DB Backup class.                                |
		|-----------------------------------------------------------------------|
	*/

	require_once 'mysql_backup.class.php';
	$backup_obj = new MySQL_DB_Backup();

	//----------------------- EDIT - REQUIRED SETUP VARIABLES -----------------------

			$backup_obj->server = "$db_host";
			$backup_obj->port = 3306;
			$backup_obj->username = "$db_user";
			$backup_obj->password = "$db_pass";
			$backup_obj->database = "$db_name";

			//Tables you wish to backup. All tables in the database will be backed up if this array is null.
			$backup_obj->tables = array();

	//------------------------ END - REQUIRED SETUP VARIABLES -----------------------

	//-------------------- OPTIONAL PREFERENCE VARIABLES ---------------------

			//Add DROP TABLE IF EXISTS queries before CREATE TABLE in backup file.
			$backup_obj->drop_tables = true;

			//No table structure will be backed up if false
			$backup_obj->create_tables = true;

			//Only structure of the tables will be backed up if true.
			$backup_obj->struct_only = false;

			//Add LOCK TABLES before data backup and UNLOCK TABLES after
			$backup_obj->locks = true;

			//Include comments in backup file if true.
			$backup_obj->comments = true;

			//Directory on the server where the backup file will be placed. Used only if task parameter equals MSX_SAVE.
			$backup_obj->backup_dir = 'temp/';

			//Default file name format.
			$backup_obj->fname_format = 'm_d_Y';

			//Values you want to be intrerpreted as NULL
			$backup_obj->null_values = array( '0000-00-00', '00:00:00', '0000-00-00 00:00:00');
	//--------------------- END - OPTIONAL PREFERENCE VARIABLES ---------------------

	//---------------------- EDIT - REQUIRED EXECUTE VARIABLES ----------------------

			/*
				Task:
					MSX_STRING - Return SQL commands as a single output string.
					MSX_SAVE - Create the backup file on the server.
					MSX_DOWNLOAD - Download backup file to the user's computer.
					MSX_APPEND - Append the backup to the file on the server.

			*/
			$task = MSX_SAVE;

			//Optional name of backup file if using 'MSX_APPEND', 'MSX_SAVE' or 'MSX_DOWNLOAD'. If nothing is passed, the default file name format will be used.
			$filename = '';

			//Use GZip compression if using 'MSX_APPEND', 'MSX_SAVE' or 'MSX_DOWNLOAD'?
			$use_gzip = false;

	//--------------------- END - REQUIRED EXECUTE VARIABLES ----------------------

	//-------------------- NO NEED TO ANYTHING BELOW THIS LINE --------------------

	$result_bk = $backup_obj->Execute($task, $filename, $use_gzip);
	if (!$result_bk)
	{
		 $output = $backup_obj->error;
	}
	else
	{
		$output = 'Operation Completed Successfully At: <b>' . date('g:i:s A') . '</b><i> ( Local Server Time )</i>';
		if ($task == MSX_STRING)
		{
			$output.= '\n' . $result_bk;
		}
	}
	if ($task != MSX_DOWNLOAD)
	{
?>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<title>MySQL Backup</title>
</head>
<body>
<?
	echo $output;
?>
</body>
</html>
<?
	}
?>
